package cn.ninegame.genericframework.basic;

import android.os.Message;

/**
 * Created by Administrator on 2017-04-17.
 */

class AsyncPoster implements Runnable {

    private final PendingPostQueue queue;
    private final MsgBroker msgBroker;

    AsyncPoster(MsgBroker eventBus) {
        this.msgBroker = eventBus;
        queue = new PendingPostQueue();
    }

    public void enqueue(Message subscription, GundamMessage event) {
        PendingPost pendingPost = PendingPost.obtainPendingPost(subscription, event);
        queue.enqueue(pendingPost);
        msgBroker.getExecutorService().execute(this);
    }

    @Override
    public void run() {
        PendingPost pendingPost = queue.poll();
        if(pendingPost == null) {
            throw new IllegalStateException("No pending post available");
        }
        msgBroker.invokeSubscriber(pendingPost);
    }

}
