package cn.ninegame.genericframework.basic;

import android.os.Bundle;

import java.io.Serializable;

/**
 * Created by Administrator on 2017-04-21.
 */

public class FrameworkMessageBuilder {

    private int messageId;
    private String messageName;
    private Bundle bundleData;
    private IResultListener iResultListener;

    public static FrameworkMessageBuilder create(int messageId){
        return new FrameworkMessageBuilder(messageId);
    }

    public FrameworkMessageBuilder(int messageId){
        this.messageId = messageId;
    }

    public FrameworkMessageBuilder withData(Bundle data){
        this.bundleData = data;
        return this;
    }

    public FrameworkMessageBuilder withListener(IResultListener resultListener){
        this.iResultListener = resultListener;
        return this;
    }

    public Bundle executeSync(){
        if(bundleData!=null){
            return FrameworkFacade.sendMessageSync(this.messageId,this.bundleData);
        }else {
            return FrameworkFacade.sendMessageSync(this.messageId);
        }
    }

    public void send(){
        if(bundleData!=null && iResultListener==null){
            FrameworkFacade.sendMessage(this.messageId,this.bundleData);
        }else if(bundleData!=null && iResultListener!=null){
            FrameworkFacade.sendMessageForResult(this.messageId,this.bundleData,this.iResultListener);
        }else if(bundleData==null && iResultListener!=null){
            FrameworkFacade.sendMessageForResult(this.messageId,new Bundle(),this.iResultListener);
        }else{
            FrameworkFacade.sendMessage(this.messageId);
        }
    }
}
